* PACKAGE DADMN  !" ϳ ᥤѡ
*"                  ver 1.00                   92/06/12 numaguti
*"                  SRC:=$GC/model/agcm5/src/dynamics/dadmn.F
*"                  DOC:=$GC/model/agcm5/doc/dynamics.tex
**********************************************************************
      SUBROUTINE DYNMCS                      !"  ϳز
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     M           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     M           GAVOR , GADIV , GBVOR , GBDIV ,
     M           GTUA  , GTVA  , GTH   , GTR   ,
     I           GTVOR , GTDIV , GTT   ,
     I           IT    , DELT  , OADVNC,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM           )
*
*"              semi-implicit ʬ
*"              implicit diffusion
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY]
      REAL       GAU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAT   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAPS  ( IDIM, JDIM       )  !" ɽ
      REAL       GAQ   ( IDIM, JDIM, KMAX )  !" 漾  
      REAL       GAVOR ( IDIM, JDIM, KMAX )  !"   
      REAL       GADIV ( IDIM, JDIM, KMAX )  !" ȯ  
*"       : ʻǡ(t) <GENGD> ʻǡ(t+t)
*
      REAL       GBU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBT   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBPS  ( IDIM, JDIM       )  !" ɽ
      REAL       GBQ   ( IDIM, JDIM, KMAX )  !" 漾  
      REAL       GBVOR ( IDIM, JDIM, KMAX )  !"   
      REAL       GBDIV ( IDIM, JDIM, KMAX )  !" ȯ  
*"       : ʻǡ(t-t) <MOVGD>  ʻǡ(t)
*
      REAL       GTUA  ( IDIM, JDIM, KMAX )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, KMAX )  !" ̱ưѲ֣
      REAL       GTH   ( IDIM, JDIM, KMAX )  !" ٻѲ  
      REAL       GTR   ( IDIM, JDIM, KMAX )  !" 漾Ѳ  

      REAL       GTVOR ( IDIM, JDIM, KMAX )  !"    Ѳ
      REAL       GTDIV ( IDIM, JDIM, KMAX )  !" ȯ   Ѳ
      REAL       GTT   ( IDIM, JDIM, KMAX )  !"    Ѳ
      
*"       :  ʻѲ­
*
      INTEGER    IT                          !" ̤
      REAL       DELT                        !" ֹߦt
      LOGICAL    OADVNC                      !" 郎ʹԤ뤫ݤ
*"       :  ѿ
*
*   [INPUT]
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٲٽ
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       SIG   ( KMAX )              !" ҥ٥()
      REAL       SIGM  (KMAX+1)              !" ҥ٥(Ⱦ)
      REAL       DSIG  ( KMAX )              !" ()
      REAL       DSIGM (KMAX+1)              !" (Ⱦ)
*"        : ɸʻ
*
*   [INTERNAL SAVE]
      REAL       DMLU  ( NMDIM, KMAX, KMAX ) !" ӣɹΣ̣ʬ
      INTEGER    KPIV  ( NMDIM, KMAX       ) !" ӣɹΥԥܥå
      REAL       DELTSV                      !" t Υ
      DATA       DELTSV / 0.0  /
      SAVE       DMLU, KPIV, DELTSV
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       EDEL  ( NMDIM  )            !" ơĢա
*
      REAL       CORIOL ( IDIM, JDIM )       !" ꥪ그 
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       DIFV  ( NMDIM  )            !" ư̿ʿȻ
      REAL       DIFT  ( NMDIM  )            !" ǮʿȻ
*
      REAL       SALPHA( KMAX )              !" ſ尵μη
      REAL       SBETA ( KMAX )              !" ſ尵μη
      REAL       SKAPPA( KMAX )              !" ٱľ֤η
      REAL       ATF   ( KMAX )              !" ٱľ֤η
      REAL       BTF   ( KMAX )              !" ٱľ֤η
      REAL       TBAR  ( KMAX )              !" ܲ١٥
      REAL       TBARM ( KMAX )              !" ܲ١Ⱦ
      REAL       GG    ( KMAX )              !" ߥץꥷå
      REAL       TMTX  ( KMAX, KMAX )        !" ߥץꥷå
      REAL       WHMTX ( KMAX, KMAX )        !" ߥץꥷå
      REAL       GCMTX ( KMAX, KMAX )        !" ߥץꥷå
*
      REAL       WPHIS ( NMDIM )             !" ɽݥƥ󥷥
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           CORIOL, UVFACT, DIFV  , DIFT  ,
     &           SALPHA, SBETA , SKAPPA,
     &           ATF   , BTF   , TBAR  , TBARM ,
     &           GG    , TMTX  , WHMTX , GCMTX ,
     &           WPHIS
*
      LOGICAL    OSETC , OSETV
      DATA       OSETC , OSETV  / .FALSE., .FALSE.  /
      SAVE       OSETC , OSETV
*
*   [INTERNAL PARAM]
      LOGICAL    ODIASP
      DATA       ODIASP         / .FALSE. /
      SAVE       ODIASP
*
*   [INTERNAL WORK]
      REAL       GAPIX ( IDIM, JDIM       )  !" Фʬ
      REAL       GAPIY ( IDIM, JDIM       )  !" Фʬ
*        : 
*
      REAL       GTKE  ( IDIM, JDIM, KMAX )  !" ưͥ륮ˣ
      REAL       GTUT  ( IDIM, JDIM, KMAX )  !" ή  գ
      REAL       GTVT  ( IDIM, JDIM, KMAX )  !" ̰ή  ֣
      REAL       GTPI  ( IDIM, JDIM       )  !" Ѳ  
      REAL       GTUQ  ( IDIM, JDIM, KMAX )  !" 漾ή  գ
      REAL       GTVQ  ( IDIM, JDIM, KMAX )  !" 漾̰ή  ֣
      REAL       GSIGD ( IDIM, JDIM, KMAX+1 )!" ҤλѲ
      REAL       GPID  ( IDIM, JDIM       )  !" ФλѲ
*"       : Ѳ
*
      REAL       WDVOR ( NMDIM , KMAX     )  !"   
      REAL       WDDIV ( NMDIM , KMAX     )  !" ȯ  
      REAL       WDT   ( NMDIM , KMAX     )  !"   
      REAL       WDPI  ( NMDIM            )  !" log Ps
      REAL       WDQ   ( NMDIM , KMAX     )  !" 漾  
*"       : ڥȥǡ
*
      REAL       WTVOR ( NMDIM, KMAX      )  !"   
      REAL       WTDIV ( NMDIM, KMAX      )  !" ȯ  
      REAL       WTT   ( NMDIM, KMAX      )  !"   
      REAL       WTPI  ( NMDIM            )  !" logPs 
      REAL       WTQ   ( NMDIM, KMAX      )  !" 漾  
      REAL       WTVDIF( NMDIM, KMAX      )  !"   
      REAL       WTDDIF( NMDIM, KMAX      )  !" ȯ  

      REAL       WTVORW ( NMDIM, KMAX      )  !"   
      REAL       WTDIVW ( NMDIM, KMAX      )  !" ȯ  
      REAL       WTTW   ( NMDIM, KMAX      )  !"   
      
*"       : ڥȥѲ
*
*
*"  << SETCON :  >>
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  ,
     O           CORIOL, UVFACT, DIFV  , DIFT  ,
     C           ALAT  , DLAT                   )
      ENDIF
*   [ONCE]
      IF ( .NOT. OSETV ) THEN
         OSETV = .TRUE.
         CALL    DSETV                 !" ľʬ
     O         ( SALPHA, SBETA , SKAPPA,
     O           ATF   , BTF   , TBAR  , TBARM ,
     O           GG    , TMTX  , WHMTX , GCMTX ,
     C           SIG   , SIGM  , DSIG            )
*
         CALL    DHSTRG                !" 
      ENDIF
*
      IF ( DELT .NE. DELTSV ) THEN
         CALL DMTRIX                   !" ߥץꥷåѹ
     O         ( DMLU  , KPIV  ,
     I           DELT  ,
     C           WHMTX , GCMTX ,
     C           NMO   , ER    , DIFV  , DIFT  )
         DELTSV = DELT
      ENDIF
*
      CALL SETPHS                      !" ɽݥƥ󥷥
     O         ( WPHIS ,
     I           IT      )
*
*" << TNDNCY : Ѳ >>
*
      CALL PIXPIY                      !" ɽ
     O         ( GAPIX , GAPIY ,
     I           GAPS            )
*
      CALL GRDDYN                      !"  ϳع
     M         ( GTUA  , GTVA  , GTH   , GTR   ,
     O           GTKE  , GTUT  , GTVT  , GTPI  , GTUQ  , GTVQ  ,
     O           GSIGD , GPID  ,
     I           GAU   , GAV   , GAT   , GAQ   ,
     I           GAVOR , GADIV , GAPIX , GAPIY ,
     C           CORIOL, UVFACT, SIGM  , DSIG  ,
     C           SALPHA, SBETA , SKAPPA,
     C           ATF   , BTF   , TBAR  , TBARM                   )
*
      CALL TENG2W                      !" Ѳ򥹥ڥȥ
     O         ( WTVOR , WTDIV , WTT   , WTPI  , WTQ   ,
     I           GTUA  , GTVA  , GTKE  , GTUT  , GTVT  , GTH   ,
     I           GTPI  , GTUQ  , GTVQ  , GTR   ,
     C           FLAPLA                                          )
*
      CALL GD2WD                       !" ǡ򥹥ڥȥ
     O         ( WDVOR , WDDIV , WDT   , WDPI  , WDQ   ,
     I           GBVOR , GBDIV , GBT   , GBPS  , GBQ    )
*

*" << GTVOR, GTDIV, GTT 򥹥ڥȥǡ >>

         CALL DSMG2S
     O         ( WTVORW ,
     I           GTVOR  )

         CALL DSMG2S
     O         ( WTDIVW ,
     I           GTDIV  )

         CALL DSMG2S
     O         ( WTTW ,
     I           GTT  )

*" << WTVOR, WTDIV, WTT ؤɲ >>

      DO K = 1 , KMAX
         DO NM = 1 , NMDIM
            WTVOR( NM,K ) = WTVOR( NM,K ) + WTVORW( NM,K )
*
            WTDIV( NM,K ) = WTDIV( NM,K ) + WTDIVW( NM,K )
*
            WTT( NM,K )   = WTT( NM,K )   + WTTW( NM,K )
*
         END DO
      END DO
*
      
*" << INTGR : ʬ >>
*
      CALL TINTGR                      !" ڥȥʬ
     M         ( WDVOR , WDDIV , WDT   , WDPI  , WDQ   ,
     I           WTVOR , WTDIV , WTT   , WTPI  , WTQ   ,
     I           DMLU  , KPIV  , DELT  ,
     C           DIFV  , DIFT  , FLAPLA, WPHIS ,
     C           GG    , TMTX  , DSIG                   )
*
      IF ( OADVNC ) THEN
         CALL MOVGD                    !" ʻͤλդѤ
     O         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     O           GBVOR , GBDIV ,
     I           GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV                          )
      ENDIF
*
      CALL GENGD                       !" ʻͤ
     O         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     I           WDVOR , WDDIV , WDT   , WDPI  , WDQ   ,
     C           EDEL  , UVFACT                          )
*
*" << CORRCT :  >>
*
      CALL TENDIF                      !" ʿȻˤѲ
     O         ( WTVDIF, WTDDIF,
     I           WDVOR , WDDIV ,
     I           DIFV           )
*
      CALL CORDIF                      !" ʿȻ໤Ǯ
     M         ( GAT   ,
     I           WTVDIF, WTDDIF,
     I           GAU   , GAV   , DELT  ,
     C           EDEL  , UVFACT         )
*
*" << OUTPUT :  >>
*
      CALL HISTIN ( GSIGD , 'SIGDOT')  !" ΰ
      CALL HISTIN ( GPID  , 'PIDOT' )
*
      CALL DDIAG                       !" 
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV                          )
*
      IF ( ODIASP ) THEN
        CALL SPCTLD                    !" ڥȥǤο
     I         ( WDVOR , 'VOR' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDDIV , 'DIV' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDT   , 'TMP' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDQ   , 'Q'   , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDPI  , 'PI'  , 1     , NMO   )
      ENDIF
*
      RETURN
*======================================================================
      ENTRY DSTRT                      !" ǡκ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     C           ALAT  , DLAT                           )
*
*   [MODIFY]
*     REAL       GAU   ( IDIM, JDIM, KMAX )  !"   
*     REAL       GAV   ( IDIM, JDIM, KMAX )  !"   
*     REAL       GAT   ( IDIM, JDIM, KMAX )  !"   
*     REAL       GAPS  ( IDIM, JDIM       )  !" ɽ
*     REAL       GAQ   ( IDIM, JDIM, KMAX )  !" 漾  
*
*   [OUTNPUT]
*     REAL       GAVOR ( IDIM, JDIM, KMAX )  !"   
*     REAL       GADIV ( IDIM, JDIM, KMAX )  !" ȯ  
*
*   [INPUT]
*     REAL       ALAT  ( JDIM )              !" 
*     REAL       DLAT  ( JDIM )              !" ٲٽ
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  ,
     O           CORIOL, UVFACT, DIFV  , DIFT  ,
     C           ALAT  , DLAT                   )
      ENDIF
*
      CALL STRTV                       !" ǡ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     C           EDEL  , UVFACT,
     W           WDVOR , WDDIV , WDT   , WDPI  , WDQ    )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE DHSTRG                !" ϳشطϤϿ
*
*   [INTERNAL PARAM]
      INTEGER    ISTYPL
      DATA       ISTYPL / 1 /
*
*   [INTERNAL WORK]
      REAL       VMISS
*
      CALL GZDBGT ( 'MISS' , VMISS )   !" »
*
      CALL HISTRG                      !" Ͽ
     I       ( 'SIGDOT', 'sigma-vertical vel. ' ,'1/s   ', 'AMLEV',
     I           VMISS , VMISS , VMISS , VMISS , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      CALL HISTRG
     I       ( 'PIDOT ', 'pi-tendency         ' ,'1/s   ', 'ASFC',
     I           VMISS , VMISS , VMISS , VMISS , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      RETURN
      END
